VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "OpenFileDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Public NotInheritable Class OpenFileDialog
'          Inherits System.Windows.Forms.FileDialog
Option Explicit ' Zeilen: 546
Private Const WS_CHILD As Long = &H40000000
Private Const WS_VISIBLE As Long = &H10000000

Private Type WinRect
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Public Enum DialogResult
  DialogResult_None = 0
  DialogResult_OK = VbMsgBoxResult.vbOK
  DialogResult_Cancel = VbMsgBoxResult.vbCancel
  DialogResult_Abort = VbMsgBoxResult.vbAbort
  DialogResult_Retry = VbMsgBoxResult.vbRetry
  DialogResult_Ignore = VbMsgBoxResult.vbIgnore
  DialogResult_Yes = VbMsgBoxResult.vbYes
  DialogResult_No = VbMsgBoxResult.vbNo
End Enum

Private Type OPENFILENAME
  lStructSize       As Long
  hwndOwner         As Long
  hInstance         As Long
  lpstrFilter       As String
  lpstrCustomFilter As String
  nMaxCustFilter    As Long
  nFilterIndex      As Long
  lpstrFile         As String
  nMaxFile          As Long
  lpstrFileTitle    As String
  nMaxFileTitle     As Long
  lpstrInitialDir   As String
  lpstrTitle        As String
  flags             As Long
  nFileOffset       As Integer
  nFileExtension    As Integer
  lpstrDefExt       As String
  lCustData         As Long
  lpfnHook          As Long
  lpTemplateName    As String
End Type

Private Const OFN_SHAREWARN             As Long = 0&
Private Const OFN_SHARENOWARN           As Long = 1&
Private Const OFN_SHAREFALLTHROUGH      As Long = 2&

Private Const OFN_EX_NOPLACESBAR        As Long = &H1

Private Const OFN_READONLY              As Long = &H1&
Private Const OFN_OVERWRITEPROMPT       As Long = &H2&
Private Const OFN_HIDEREADONLY          As Long = &H4&
Private Const OFN_NOCHANGEDIR           As Long = &H8&

Private Const OFN_SHOWHELP              As Long = &H10&
Private Const OFN_ENABLEHOOK            As Long = &H20&
Private Const OFN_ENABLETEMPLATE        As Long = &H40&
Private Const OFN_ENABLETEMPLATEHANDLE  As Long = &H80&

Private Const OFN_NOVALIDATE            As Long = &H100&
Private Const OFN_ALLOWMULTISELECT      As Long = &H200&
Private Const OFN_EXTENSIONDIFFERENT    As Long = &H400&
Private Const OFN_PATHMUSTEXIST         As Long = &H800&

Private Const OFN_FILEMUSTEXIST         As Long = &H1000&
Private Const OFN_CREATEPROMPT          As Long = &H2000&
Private Const OFN_SHAREAWARE            As Long = &H4000&
Private Const OFN_NOREADONLYRETURN      As Long = &H8000&

Private Const OFN_NOTESTFILECREATE      As Long = &H10000
Private Const OFN_NONETWORKBUTTON       As Long = &H20000
Private Const OFN_NOLONGNAMES           As Long = &H40000
Private Const OFN_EXPLORER              As Long = &H80000

Private Const OFN_NODEREFERENCELINKS    As Long = &H100000
Private Const OFN_LONGNAMES             As Long = &H200000
Private Const OFN_ENABLEINCLUDENOTIFY   As Long = &H400000
Private Const OFN_ENABLESIZING          As Long = &H800000

Private Const OFN_USEMONIKERS           As Long = &H1000000
Private Const OFN_DONTADDTORECENT       As Long = &H2000000
Private Const OFN_FORCESHOWHIDDEN       As Long = &H10000000

'Diese Klasse funktioniert unter VB6 genauso wie die
'Klasse OpenFileDialog von .NET
'also die wichtigsten Sachen
'
'CommonDialog
'Microsoft Common Dialog Control 6.0 (SP6)
'in: \System32\COMDLG32.OCX
'ist nur eine dnne Kapselung der dll "comdlg32.dll"
'deshalb lieber gleich die dll-verwenden, hat den Vorteil, da comdlg32.ocx
'nicht mit dem Programm ausgeliefert werden mu,
'da die comdlg32.dll Bestandteil des Betriebssystems ist
'Private Base As New FileDialog
Private mAddExtension     As Boolean
'Private mCheckFileExists As Boolean
'Private mCheckPathExists As Boolean
Private mDefaultExt       As String
'Private mDereferenceLinks As Boolean
Private mFileName         As String
Private mFileNames        As Collection    'ReadOnly nur Get
Private mFilter           As String
Private mFilterIndex      As Long
Private mInitialDirectory As String
'Private mShowReadOnly As Boolean
Private mTitle            As String
Private mValidateNames    As Boolean
Private mFlags            As Long
Private mTag              As Variant

Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
'Private Declare Function GetOpenFileNamePreview Lib "msvfw32.dll" (ByRef lpofn As OPENFILENAME) As Long
Private Declare Function GetActiveWindow Lib "user32.dll" () As Long
Private Declare Function GetDesktopWindow Lib "user32.dll" () As Long
Private Declare Function CreateWindowExA Lib "user32.dll" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, ByRef lpParam As Any) As Long
Private Declare Function GetWindowRect Lib "user32.dll" (ByVal hhwnd As Long, ByRef lpRect As WinRect) As Long

Private Sub Class_Initialize()
    Call Reset
End Sub
Public Sub Reset()
    'Call InitFlags
    mFlags = mFlags Or OFN_EXPLORER
    mFlags = mFlags Or OFN_FILEMUSTEXIST
    mFlags = mFlags Or OFN_HIDEREADONLY
    mFlags = mFlags Or OFN_PATHMUSTEXIST
  
    mAddExtension = True
    'Set mFileNames = New Collection  'ReadOnly nur Get
    Call FNsColInitClear
    mFilterIndex = 1           'nFilterIndex
    'mTitle = "Open"                '
    mValidateNames = True      'OFN_NOVALIDATE
End Sub
Private Sub FNsColInitClear()
    Set mFileNames = New Collection
End Sub

Private Sub InitFlags() 'in Modul ModCommonDialogs.bas
    'mFlags = mFlags Or OFN_ALLOWMULTISELECT
    'mFlags = mFlags Or OFN_CREATEPROMPT
    'mFlags = mFlags Or OFN_DONTADDTORECENT
    'mFlags = mFlags Or OFN_ENABLEHOOK
    'mFlags = mFlags Or OFN_ENABLEINCLUDENOTIFY
    'mFlags = mFlags Or OFN_ENABLESIZING
    'mFlags = mFlags Or OFN_ENABLETEMPLATE
    'mFlags = mFlags Or OFN_ENABLETEMPLATEHANDLE
    'mFlags = mFlags Or OFN_EX_NOPLACESBAR
    mFlags = mFlags Or OFN_EXPLORER
    'mFlags = mFlags Or OFN_EXTENSIONDIFFERENT
    mFlags = mFlags Or OFN_FILEMUSTEXIST
    'mFlags = mFlags Or OFN_FORCESHOWHIDDEN
    mFlags = mFlags Or OFN_HIDEREADONLY
    'mFlags = mFlags Or OFN_LONGNAMES
    'mFlags = mFlags Or OFN_NOCHANGEDIR
    'mFlags = mFlags Or OFN_NODEREFERENCELINKS
    'mFlags = mFlags Or OFN_NOLONGNAMES
    'mFlags = mFlags Or OFN_NONETWORKBUTTON
    'mFlags = mFlags Or OFN_NOREADONLYRETURN
    'mFlags = mFlags Or OFN_NOTESTFILECREATE
    'mFlags = mFlags Or OFN_NOVALIDATE
    'mFlags = mFlags Or OFN_OVERWRITEPROMPT
    mFlags = mFlags Or OFN_PATHMUSTEXIST
    'mFlags = mFlags Or OFN_READONLY
    'mFlags = mFlags Or OFN_SHAREAWARE
    'mFlags = mFlags Or OFN_SHAREFALLTHROUGH
    'mFlags = mFlags Or OFN_SHARENOWARN
    'mFlags = mFlags Or OFN_SHAREWARN
    'mFlags = mFlags Or OFN_SHOWHELP
    'mFlags = mFlags Or OFN_USEMONIKERS
End Sub
Friend Property Get flags() As Long
    flags = mFlags
End Property
Friend Property Let flags(RHS As Long)
    mFlags = RHS
End Property

'Ruft einen Wert ab, oder legt diesen fest, der angibt,
'ob einem Dateinamen im Dialogfeld automatisch eine Erweiterung
'hinzugefgt wird wenn der Benutzer keine Erweiterung angibt
Public Property Get AddExtension() As Boolean
    AddExtension = mAddExtension
End Property
Public Property Let AddExtension(BolVal As Boolean)
    mAddExtension = BolVal
End Property

'Public Overrides Property CheckFileExists() As Boolean
Public Property Get CheckFileExists() As Boolean       'OFN_FILEMUSTEXIST
    'CheckFileExists = mCheckFileExists
    CheckFileExists = mFlags And OFN_FILEMUSTEXIST
End Property
Public Property Let CheckFileExists(BolVal As Boolean)       'OFN_FILEMUSTEXIST
    'mCheckFileExists = BolVal
    mFlags = mFlags Or OFN_FILEMUSTEXIST
    If Not BolVal Then
        mFlags = mFlags Xor OFN_FILEMUSTEXIST
    End If
End Property

Public Property Get CheckPathExists() As Boolean         'OFN_PATHMUSTEXIST
     'CheckPathExists = mCheckPathExists
    CheckPathExists = mFlags And OFN_PATHMUSTEXIST
End Property
Public Property Let CheckPathExists(BolVal As Boolean)         'OFN_PATHMUSTEXIST
    'mCheckPathExists = BolVal
    mFlags = mFlags Or OFN_PATHMUSTEXIST
    If Not BolVal Then
        mFlags = mFlags Xor OFN_PATHMUSTEXIST
    End If
End Property

'Public Property DefaultExt() As String
Public Property Get DefaultExt() As String
    DefaultExt = mDefaultExt
End Property
Public Property Let DefaultExt(StrExt As String)
    mDefaultExt = StrExt
End Property

'Public Property DereferenceLinks() As Boolean
Public Property Get DereferenceLinks() As Boolean       'OFN_NODEREFERENCELINKS
    'DereferenceLinks = mDereferenceLinks
    DereferenceLinks = mFlags And OFN_NODEREFERENCELINKS
End Property
Public Property Let DereferenceLinks(BolVal As Boolean) 'OFN_NODEREFERENCELINKS
    mFlags = mFlags Or OFN_NODEREFERENCELINKS
    If BolVal Then
        mFlags = mFlags Xor OFN_NODEREFERENCELINKS
    End If
End Property

'Public Property Let DereferenceLinks(BolVal As Boolean) 'OFN_NODEREFERENCELINKS
'  mFlags = mFlags Or OFN_NODEREFERENCELINKS
'  If BolVal Then
'    mFlags = mFlags Xor OFN_NODEREFERENCELINKS
'  End If
'End Property

'Public Property FileName() As String
Public Property Get FileName() As String
    FileName = mFileName
End Property
Public Property Let FileName(StrFN As String)
    mFileName = StrFN
End Property

'Public ReadOnly Property FileNames() As String()
Public Property Get FileNames() As Collection 'ReadOnly nur Get
    Set FileNames = mFileNames
End Property

Private Sub GetFNsinCol(FNs As String)
    Dim i As Integer
    Dim aa As String, bb As String, Path As String
    Dim PathFirst As Boolean
    Dim FirstFile As Boolean
    Dim pos As Long, X As Long, xOld As Long
    Dim FN As String
    PathFirst = False
    FirstFile = True
    Call FNsColInitClear
          
    'Schauen ob evt. nur eine Datei ausgewhlt wurde
    Call TrimVBNullchar(FNs)
    If InStr(FNs, vbNullChar) <> 0 Then
        aa = FNs & vbNullChar
        pos = 1
        
        Do
            'Chr$(0) ist Trennzeichen
            X = InStr(pos, aa, vbNullChar)
            If X = xOld + 1 Then 'zwei vbnullchar hintereinander, dann aufhren
                Exit Do
            End If
            xOld = X
            If X = 0 Then Exit Do
            bb = Mid$(aa, pos, X - pos)
               
            If Not PathFirst Then
                'Im ersten Teil befindet sich immer der Pfad
                Path = bb
                If Not VBA.Right$(Path, 1) = "\" Then Path = Path & "\"
                PathFirst = True
            Else
                'Pfad ist bereits bekannt, es folgen Dateinamen
                If FirstFile Then
                    mFileName = Path & bb
                    FirstFile = False
                End If
                Call mFileNames.Add(Path & bb)
            End If
            pos = X + 1
        Loop
    Else
        'Es wurde nur eine Datei ausgewhlt
        'Call mFileNames.Add(FNs)
        FN = FNs
        mFileName = FN
    End If
End Sub
Private Sub TrimVBNullchar(ByRef StrVal As String) 'As String
    Dim i As Long
    Dim sepStr As String
    For i = 1 To Len(StrVal)
        sepStr = vbNullChar + vbNullChar
        If Mid$(StrVal, i, 2) = sepStr Then
            StrVal = VBA.Left$(StrVal, i - 1)
            Exit For
        End If
    Next
End Sub

'Public Property Filter() As String
Public Property Get Filter() As String
    Dim i As Integer
    Dim StrFlt As String
    StrFlt = mFilter
    For i = 1 To Len(StrFlt)
        If Mid$(StrFlt, i, 1) = vbNullChar Then Mid$(StrFlt, i, 1) = "|"
    Next
    Filter = StrFlt
End Property
Public Property Let Filter(StrVal As String)
Dim i As Integer
Dim StrFlt As String
  StrFlt = StrVal
  For i = 1 To Len(StrFlt)
    If Mid$(StrFlt, i, 1) = "|" Then Mid$(StrFlt, i, 1) = vbNullChar
  Next
  If Not Right$(StrFlt, 2) = vbNullChar + vbNullChar Then StrFlt = StrFlt + vbNullChar + vbNullChar
  mFilter = StrFlt
End Property

'Public Property FilterIndex() As Integer
Public Property Get FilterIndex() As Long
  FilterIndex = mFilterIndex
End Property
Public Property Let FilterIndex(IntVal As Long)
  mFilterIndex = IntVal
End Property

'Ruft das Ausgangsverzeichnis ab, oder legt dieses fest
Public Property Get InitialDirectory() As String       'lpstrInitialDir
  InitialDirectory = mInitialDirectory
End Property
Public Property Let InitialDirectory(StrVal As String) 'lpstrInitialDir
  mInitialDirectory = StrVal
End Property

Public Property Get MultiSelect() As Boolean         'OFN_ALLOWMULTISELECT
  MultiSelect = mFlags And OFN_ALLOWMULTISELECT
End Property
Public Property Let MultiSelect(BolVal As Boolean)   'OFN_ALLOWMULTISELECT
  mFlags = mFlags Or OFN_ALLOWMULTISELECT
  If Not BolVal Then
    mFlags = mFlags Xor OFN_ALLOWMULTISELECT
  End If
End Property

Public Property Get ReadOnlyChecked() As Boolean       'OFN_READONLY
  ReadOnlyChecked = mFlags And OFN_READONLY
End Property
Public Property Let ReadOnlyChecked(BolVal As Boolean) 'OFN_READONLY
  mFlags = mFlags Or OFN_READONLY
  If Not BolVal Then
    mFlags = mFlags Xor OFN_READONLY
  End If
End Property

'ruft einen Wert ab, oder legt diesen fest, der angibt,
'ob das Dialogfeld das vor dem Schlieen aktuelle Verzeichnis wiederherstellt,
Public Property Get RestoreDirectory() As Boolean       'OFN_NOCHANGEDIR
  RestoreDirectory = mFlags And OFN_NOCHANGEDIR
End Property
Public Property Let RestoreDirectory(BolVal As Boolean) 'OFN_NOCHANGEDIR
  mFlags = mFlags Or OFN_NOCHANGEDIR
  If Not BolVal Then
    mFlags = mFlags Xor OFN_NOCHANGEDIR
  End If
End Property

'Public Property ShowHelp() As Boolean
Public Property Get ShowHelp() As Boolean           'OFN_SHOWHELP
  ShowHelp = mFlags And OFN_SHOWHELP
End Property
Public Property Let ShowHelp(BolVal As Boolean)     'OFN_SHOWHELP
  mFlags = mFlags Or OFN_SHOWHELP
  If Not BolVal Then
    mFlags = mFlags Xor OFN_SHOWHELP
  End If
End Property

'Public Property ShowReadOnly() As Boolean
Public Property Get ShowReadOnly() As Boolean       'OFN_HIDEREADONLY
  'ShowReadOnly = mShowReadOnly
  ShowReadOnly = mFlags And OFN_HIDEREADONLY
End Property
Public Property Let ShowReadOnly(BolVal As Boolean) 'OFN_HIDEREADONLY
  'mShowReadOnly = BolVal
  mFlags = mFlags Or OFN_HIDEREADONLY
  If BolVal Then
    mFlags = mFlags Xor OFN_HIDEREADONLY
  End If
End Property
'Private Sub mShowReadOnly_OnLet(ByVal sender As Object)
'  mFlags = mFlags Or OFN_HIDEREADONLY
'  If BolVal Then
'    mFlags = mFlags Xor OFN_HIDEREADONLY
'  End If
'End Sub

'wie schon hinlnglich bekann, fg einfach irgendwas hinzu
'wird intern nicht verwendet, kann extern verwendet werden
'Public Property Get Tag() As Object
Public Property Get Tag() As Variant
  Tag = mTag
End Property
Public Property Let Tag(VarVal As Variant)
  mTag = VarVal
End Property

Public Function ToString() As String
  ToString = "MBO.Windows.Forms.OpenFileDialog: " & "Title: " & mTitle & " , FileName: " & mFileName
End Function

Public Property Get Title() As String       'lpstrTitle
  Title = mTitle
End Property
Public Property Let Title(StrVal As String) 'lpstrTitle
  mTitle = StrVal
End Property

'ob das Dialogfeld nur gltige Win32-Dateinamen akzeptiert
Public Property Get ValidateNames() As Boolean       'OFN_NOVALIDATE
  ValidateNames = mFlags And OFN_NOVALIDATE
End Property
Public Property Let ValidateNames(BolVal As Boolean) 'OFN_NOVALIDATE
  mFlags = mFlags Or OFN_NOVALIDATE
  If BolVal Then
    mFlags = mFlags Xor OFN_NOVALIDATE
  End If
End Property

Public Function ShowDialog(Optional frm As Variant) As DialogResult
Dim OFN As OPENFILENAME
Dim mMaxLenFN As Long
Dim Buffer As String
Dim Result As Long
Dim myFrm As Form
Dim myOwnerhwnd As Long
Dim myOwnerhInst As Long
Dim FN As String

TryE: On Error GoTo CatchE
  
  If Not IsMissing(frm) Then
    'myOwnerHwnd = GetDesktopWindow 'CreateWindowEx(0, "window", "anewwindow", 0, 250, 250, 1, 1, 0, 0, App.hInstance, 0) ''Frm.hwnd
    myOwnerhwnd = frm.hWnd 'GetCenteredHwnd
  Else
    myOwnerhwnd = GetActiveWindow
    'myOwnerhwnd = GetCenteredHwnd 'see below
    'myOwnerHwnd = GetDesktopWindow 'GetActiveWindow
  End If
  'myOwnerhInst = App.hInstance
  myOwnerhInst = 0
  mMaxLenFN = 32767 - Len(mFileName)
  Buffer = mFileName & String$(mMaxLenFN, vbNullChar)
  
  With OFN
    .lStructSize = Len(OFN)
    .hwndOwner = myOwnerhwnd
    .hInstance = myOwnerhInst
    .lpstrFilter = mFilter
    '.lpstrCustomFilter = mDefaultExt
    'nMaxCustFilter
    .nFilterIndex = mFilterIndex '(FilterIndex)
    .lpstrFile = Buffer
    .nMaxFile = Len(Buffer) '32767
    'lpstrFileTitle 'der NurDateiName ohne Extension
    'nMaxFileTitle
    .lpstrInitialDir = mInitialDirectory
    .lpstrTitle = Title
    .flags = mFlags
    'nFileOffset
    'nFileExtension
    .lpstrDefExt = mDefaultExt
    'lCustData
    'lpfnHook
    'lpTemplateName
  End With
  Result = GetOpenFileName(OFN)
  'Result = GetOpenFileNamePreview(OFN)
  If Result <> 0 Then
    'man mu am String erkennen, ob nur eine oder mehrere Dateien ausgewhlt wurden
    Call GetFNsinCol(OFN.lpstrFile)
    ShowDialog = DialogResult.DialogResult_OK
  Else
    If mFlags And OFN_ALLOWMULTISELECT Then
      Call GetFNsinCol(OFN.lpstrFile)
    End If
    ShowDialog = DialogResult.DialogResult_Cancel
    'oder zuviele Dateien
  End If
  Exit Function
CatchE:
  If Err.Number = 32755 Then
    ShowDialog = DialogResult.DialogResult_Cancel
  Else
    'MsgBox CStr(Err.Number) & " " & Err.Description
    Call ErrHandler("ShowDialog")
  End If
End Function

Private Function GetCenteredHwnd() As Long
Dim dwr As WinRect
Dim Dhwnd As Long
Dim cwhwnd As Long
  Dhwnd = GetDesktopWindow
  Call GetWindowRect(Dhwnd, dwr)
  'Debug.Print CStr(dwr.Left) & " " & CStr(dwr.Top) & " " & CStr(dwr.Right) & " " & CStr(dwr.Bottom)
  'GetWindowRect
  'um die genaue zentrierte Position bestimmen zu knne, mte man doch zuerst wissen
  'wie gro der OpenFileDialog berhaupt ist
         '(dwExStyle Long, lpClassName String, lpWindowName String, dwStyle As Long, X As Long, y As Long, nWidth As Long, nHeight As Long, hWndParent As Long, hMenu As Long, hInstance As Long, ByRef lpParam As Any)
  cwhwnd = CreateWindowExA(0, "Window", "OpenDialog", WS_CHILD Or WS_VISIBLE, 512, 384, 1, 1, Dhwnd, 0, App.hInstance, 0)
  Debug.Print CStr(cwhwnd)
  GetCenteredHwnd = cwhwnd
End Function

'##############################'   Locale ErrHandler   '##############################'
Private Function ErrHandler(ByVal PrcName As String, _
                            Optional AddInfo As String, _
                            Optional BolLoud As Boolean = True, _
                            Optional bErrLog As Boolean = True, _
                            Optional vbDecor As VbMsgBoxStyle = vbOKOnly Or vbCritical _
                            ) As VbMsgBoxResult
  'ErrHandler = GlobalErrhandler(Me, PrcName, AddInfo, BolLoud, bErrLog, vbDecor)
  ErrHandler = GlobalErrhandler("OpenFileDialog", PrcName, vbDecor)
End Function




